import{s as xt,o as wt,n as Ct}from"../chunks/scheduler.c57aa7ef.js";import{S as Bt,i as Lt,g as n,s as a,r as f,A as Mt,h as s,f as o,c as r,j as w,u as g,x as i,k as C,y as t,a as $,v as h,d as _,t as b,w as v}from"../chunks/index.c50cb18e.js";import{D as k}from"../chunks/Docstring.b594fb60.js";import{C as Pt}from"../chunks/CodeBlock.34f0a53d.js";import{E as jt}from"../chunks/ExampleCodeBlock.4831c5ad.js";import{H as at}from"../chunks/Heading.c7d7e0e7.js";function kt($e){let u,j;return u=new Pt({props:{code:"Zm9yJTIwbmFtZSUyQyUyMHBhcmFtJTIwaW4lMjBtb2RlbF9wZWZ0Lm5hbWVkX3BhcmFtZXRlcnMoKSUzQSUwQSUyMCUyMCUyMCUyMGlmJTIwLi4uJTNBJTIwJTIwJTIzJTIwc29tZSUyMGNoZWNrJTIwb24lMjBuYW1lJTIwKGV4LiUyMGlmJTIwJ2xvcmEnJTIwaW4lMjBuYW1lKSUwQSUyMCUyMCUyMCUyMCUyMCUyMCUyMCUyMHBhcmFtLnJlcXVpcmVzX2dyYWQlMjAlM0QlMjBGYWxzZQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> name, param <span class="hljs-keyword">in</span> model_peft.named_parameters():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> ...:  <span class="hljs-comment"># some check on name (ex. if &#x27;lora&#x27; in name)</span>
<span class="hljs-meta">... </span>        param.requires_grad = <span class="hljs-literal">False</span>`,wrap:!1}}),{c(){f(u.$$.fragment)},l(m){g(u.$$.fragment,m)},m(m,R){h(u,m,R),j=!0},p:Ct,i(m){j||(_(u.$$.fragment,m),j=!0)},o(m){b(u.$$.fragment,m),j=!1},d(m){v(u,m)}}}function It($e){let u,j,m,R,H,ye,J,rt="A tuner (or adapter) is a module that can be plugged into a <code>torch.nn.Module</code>. <code>BaseTuner</code> base class for other tuners and provides shared methods and attributes for preparing an adapter configuration and replacing a target module with the adapter module. <code>BaseTunerLayer</code> is a base class for adapter layers. It offers methods and attributes for managing adapters such as activating and disabling adapters.",Te,A,xe,d,V,Pe,X,nt=`A base tuner model that provides the common methods and attributes for all tuners that are injectable into a
torch.nn.Module`,je,Y,st="For adding a new Tuner class, one needs to overwrite the following methods:",ke,K,ot=`<li><strong>_prepare_adapter_config</strong>:
A private method to eventually prepare the adapter config, for example in case the field <code>target_modules</code> is
missing.</li> <li><strong>_create_and_replace</strong>:
A private method to create and replace the target module with the adapter module.</li> <li><strong>_check_target_module_exists</strong>:
A private helper method to check if the passed module’s key name matches any of the target modules in the
adapter_config.</li>`,Ie,O,lt="The easiest is to check what is done in the <code>peft.tuners.lora.LoraModel</code> class.",Ue,B,q,De,ee,dt=`Creates adapter layers and replaces the target modules with the adapter layers. This method is called under the
hood by <code>peft.mapping.get_peft_model</code> if a non-prompt tuning adapter class is passed.`,Ee,te,it="The corresponding PEFT config is directly retrieved from the <code>peft_config</code> attribute of the BaseTuner class.",He,L,N,Je,ae,pt="This method merges the adapter layers into the base model.",Ae,re,ut=`Merging adapters can lead to a speed up of the forward pass. A copy of the adapter weights is still kept in
memory, which is required to unmerge the adapters. In order to merge the adapter weights without keeping them
in memory, please call <code>merge_and_unload</code>.`,Ve,I,S,qe,ne,ct="This method unmerges all merged adapter layers from the base model.",we,F,Ce,c,W,Ne,se,mt="A tuner layer mixin that provides the common methods and attributes for all tuners.",Se,y,Z,Fe,oe,ft="Delete an adapter from the layer",We,le,gt="This should be called on all adapter layers, or else we will get an inconsistent state.",Ze,de,ht=`This method will also set a new active adapter if the deleted adapter was an active adapter. It is important
that the new adapter is chosen in a deterministic way, so that the same adapter is chosen on all layers.`,Qe,M,Q,ze,ie,_t="Toggle the enabling and disabling of adapters",Ge,pe,bt="Takes care of setting the requires_grad flag for the adapter weights.",Re,P,z,Xe,ue,vt="(Recursively) get the base_layer.",Ye,ce,$t="This is necessary for the case that the tuner layer wraps another tuner layer.",Ke,T,G,Oe,me,yt="Set the active adapter(s).",et,fe,Tt=`Additionally, this function will set the specified adapters to trainable (i.e., requires_grad=True). If this is
not desired, use the following code.`,tt,U,Be,ve,Le;return H=new at({props:{title:"Tuners",local:"tuners",headingTag:"h1"}}),A=new at({props:{title:"BaseTuner",local:"peft.tuners.tuners_utils.BaseTuner",headingTag:"h2"}}),V=new k({props:{name:"class peft.tuners.tuners_utils.BaseTuner",anchor:"peft.tuners.tuners_utils.BaseTuner",parameters:[{name:"model",val:""},{name:"peft_config",val:": Union[PeftConfig, dict[str, PeftConfig]]"},{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to which the adapter tuner layers will be attached.`,name:"model"},{anchor:"peft.tuners.tuners_utils.BaseTuner.forward",description:`<strong>forward</strong> (<code>Callable</code>) &#x2014;
The forward method of the model.`,name:"forward"},{anchor:"peft.tuners.tuners_utils.BaseTuner.peft_config",description:`<strong>peft_config</strong> (<code>Union[</code>PeftConfig<code>, dict[str, PeftConfig]]</code>) &#x2014;
The adapter configuration object, it should be a dictionary of <code>str</code> to <code>PeftConfig</code> objects. One can also
pass a PeftConfig object and a new adapter will be created with the default name <code>adapter</code> or create a new
dictionary with a key <code>adapter_name</code> and a value of that peft config.`,name:"peft_config"},{anchor:"peft.tuners.tuners_utils.BaseTuner.config",description:`<strong>config</strong> (<code>dict[str, Any]</code>) &#x2014;
The model configuration object, it should be a dictionary of <code>str</code> to <code>Any</code> objects.`,name:"config"},{anchor:"peft.tuners.tuners_utils.BaseTuner.targeted_module_names",description:`<strong>targeted_module_names</strong> (<code>list[str]</code>) &#x2014;
The list of module names that were actually adapted. Can be useful to inspect if you want to quickly
double-check that the <code>config.target_modules</code> where specified correctly.`,name:"targeted_module_names"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L91"}}),q=new k({props:{name:"inject_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter",parameters:[{name:"model",val:": nn.Module"},{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter.model",description:`<strong>model</strong> (<code>nn.Module</code>) &#x2014;
The model to be tuned.`,name:"model"},{anchor:"peft.tuners.tuners_utils.BaseTuner.inject_adapter.adapter_name",description:`<strong>adapter_name</strong> (<code>str</code>) &#x2014;
The adapter name.`,name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L245"}}),N=new k({props:{name:"merge_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter",parameters:[{name:"adapter_names",val:": Optional[list[str]] = None"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter.safe_merge",description:`<strong>safe_merge</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If <code>True</code>, the merge operation will be performed in a copy of the original weights and check for NaNs
before merging the weights. This is useful if you want to check if the merge operation will produce
NaNs. Defaults to <code>False</code>.`,name:"safe_merge"},{anchor:"peft.tuners.tuners_utils.BaseTuner.merge_adapter.adapter_names",description:`<strong>adapter_names</strong> (<code>list[str]</code>, <em>optional</em>) &#x2014;
The list of adapter names that should be merged. If <code>None</code>, all active adapters will be merged.
Defaults to <code>None</code>.`,name:"adapter_names"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L323"}}),S=new k({props:{name:"unmerge_adapter",anchor:"peft.tuners.tuners_utils.BaseTuner.unmerge_adapter",parameters:[],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L345"}}),F=new at({props:{title:"BaseTunerLayer",local:"peft.tuners.tuners_utils.BaseTunerLayer",headingTag:"h2"}}),W=new k({props:{name:"class peft.tuners.tuners_utils.BaseTunerLayer",anchor:"peft.tuners.tuners_utils.BaseTunerLayer",parameters:[],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.is_pluggable",description:`<strong>is_pluggable</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether the adapter layer can be plugged to any pytorch module`,name:"is_pluggable"},{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.active_adapters",description:`<strong>active_adapters</strong> (Union[List<code>str</code>, <code>str</code>], <em>optional</em>) &#x2014;
The name of the active adapter.`,name:"active_adapters"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L363"}}),Z=new k({props:{name:"delete_adapter",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.delete_adapter",parameters:[{name:"adapter_name",val:": str"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.delete_adapter.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code>) &#x2014; The name of the adapter to delete",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L505"}}),Q=new k({props:{name:"enable_adapters",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.enable_adapters",parameters:[{name:"enabled",val:": bool"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.enable_adapters.enabled",description:"<strong>enabled</strong> (bool) &#x2014; True to enable adapters, False to disable adapters",name:"enabled"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L445"}}),z=new k({props:{name:"get_base_layer",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.get_base_layer",parameters:[],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L390"}}),G=new k({props:{name:"set_adapter",anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter",parameters:[{name:"adapter_names",val:": str | list[str]"}],parametersDescription:[{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter.adapter_name",description:"<strong>adapter_name</strong> (<code>str</code> or <code>List[str]</code>) &#x2014; Name of the adapter(s) to be activated.",name:"adapter_name"}],source:"https://github.com/huggingface/peft/blob/v0.9.0/src/peft/tuners/tuners_utils.py#L463"}}),U=new jt({props:{anchor:"peft.tuners.tuners_utils.BaseTunerLayer.set_adapter.example",$$slots:{default:[kt]},$$scope:{ctx:$e}}}),{c(){u=n("meta"),j=a(),m=n("p"),R=a(),f(H.$$.fragment),ye=a(),J=n("p"),J.innerHTML=rt,Te=a(),f(A.$$.fragment),xe=a(),d=n("div"),f(V.$$.fragment),Pe=a(),X=n("p"),X.textContent=nt,je=a(),Y=n("p"),Y.textContent=st,ke=a(),K=n("ul"),K.innerHTML=ot,Ie=a(),O=n("p"),O.innerHTML=lt,Ue=a(),B=n("div"),f(q.$$.fragment),De=a(),ee=n("p"),ee.innerHTML=dt,Ee=a(),te=n("p"),te.innerHTML=it,He=a(),L=n("div"),f(N.$$.fragment),Je=a(),ae=n("p"),ae.textContent=pt,Ae=a(),re=n("p"),re.innerHTML=ut,Ve=a(),I=n("div"),f(S.$$.fragment),qe=a(),ne=n("p"),ne.textContent=ct,we=a(),f(F.$$.fragment),Ce=a(),c=n("div"),f(W.$$.fragment),Ne=a(),se=n("p"),se.textContent=mt,Se=a(),y=n("div"),f(Z.$$.fragment),Fe=a(),oe=n("p"),oe.textContent=ft,We=a(),le=n("p"),le.textContent=gt,Ze=a(),de=n("p"),de.textContent=ht,Qe=a(),M=n("div"),f(Q.$$.fragment),ze=a(),ie=n("p"),ie.textContent=_t,Ge=a(),pe=n("p"),pe.textContent=bt,Re=a(),P=n("div"),f(z.$$.fragment),Xe=a(),ue=n("p"),ue.textContent=vt,Ye=a(),ce=n("p"),ce.textContent=$t,Ke=a(),T=n("div"),f(G.$$.fragment),Oe=a(),me=n("p"),me.textContent=yt,et=a(),fe=n("p"),fe.textContent=Tt,tt=a(),f(U.$$.fragment),Be=a(),ve=n("p"),this.h()},l(e){const l=Mt("svelte-u9bgzb",document.head);u=s(l,"META",{name:!0,content:!0}),l.forEach(o),j=r(e),m=s(e,"P",{}),w(m).forEach(o),R=r(e),g(H.$$.fragment,e),ye=r(e),J=s(e,"P",{"data-svelte-h":!0}),i(J)!=="svelte-dsnslo"&&(J.innerHTML=rt),Te=r(e),g(A.$$.fragment,e),xe=r(e),d=s(e,"DIV",{class:!0});var p=w(d);g(V.$$.fragment,p),Pe=r(p),X=s(p,"P",{"data-svelte-h":!0}),i(X)!=="svelte-1k0hvlq"&&(X.textContent=nt),je=r(p),Y=s(p,"P",{"data-svelte-h":!0}),i(Y)!=="svelte-fkgwsm"&&(Y.textContent=st),ke=r(p),K=s(p,"UL",{"data-svelte-h":!0}),i(K)!=="svelte-uumdnf"&&(K.innerHTML=ot),Ie=r(p),O=s(p,"P",{"data-svelte-h":!0}),i(O)!=="svelte-1sc4mfu"&&(O.innerHTML=lt),Ue=r(p),B=s(p,"DIV",{class:!0});var ge=w(B);g(q.$$.fragment,ge),De=r(ge),ee=s(ge,"P",{"data-svelte-h":!0}),i(ee)!=="svelte-1ybn6sj"&&(ee.innerHTML=dt),Ee=r(ge),te=s(ge,"P",{"data-svelte-h":!0}),i(te)!=="svelte-fvf2kw"&&(te.innerHTML=it),ge.forEach(o),He=r(p),L=s(p,"DIV",{class:!0});var he=w(L);g(N.$$.fragment,he),Je=r(he),ae=s(he,"P",{"data-svelte-h":!0}),i(ae)!=="svelte-kun7ud"&&(ae.textContent=pt),Ae=r(he),re=s(he,"P",{"data-svelte-h":!0}),i(re)!=="svelte-1f1s101"&&(re.innerHTML=ut),he.forEach(o),Ve=r(p),I=s(p,"DIV",{class:!0});var Me=w(I);g(S.$$.fragment,Me),qe=r(Me),ne=s(Me,"P",{"data-svelte-h":!0}),i(ne)!=="svelte-2eloeq"&&(ne.textContent=ct),Me.forEach(o),p.forEach(o),we=r(e),g(F.$$.fragment,e),Ce=r(e),c=s(e,"DIV",{class:!0});var x=w(c);g(W.$$.fragment,x),Ne=r(x),se=s(x,"P",{"data-svelte-h":!0}),i(se)!=="svelte-1fdxdjn"&&(se.textContent=mt),Se=r(x),y=s(x,"DIV",{class:!0});var D=w(y);g(Z.$$.fragment,D),Fe=r(D),oe=s(D,"P",{"data-svelte-h":!0}),i(oe)!=="svelte-950rwb"&&(oe.textContent=ft),We=r(D),le=s(D,"P",{"data-svelte-h":!0}),i(le)!=="svelte-1nnxg1l"&&(le.textContent=gt),Ze=r(D),de=s(D,"P",{"data-svelte-h":!0}),i(de)!=="svelte-1vxxy19"&&(de.textContent=ht),D.forEach(o),Qe=r(x),M=s(x,"DIV",{class:!0});var _e=w(M);g(Q.$$.fragment,_e),ze=r(_e),ie=s(_e,"P",{"data-svelte-h":!0}),i(ie)!=="svelte-2or2k8"&&(ie.textContent=_t),Ge=r(_e),pe=s(_e,"P",{"data-svelte-h":!0}),i(pe)!=="svelte-ujp0ui"&&(pe.textContent=bt),_e.forEach(o),Re=r(x),P=s(x,"DIV",{class:!0});var be=w(P);g(z.$$.fragment,be),Xe=r(be),ue=s(be,"P",{"data-svelte-h":!0}),i(ue)!=="svelte-6rdpda"&&(ue.textContent=vt),Ye=r(be),ce=s(be,"P",{"data-svelte-h":!0}),i(ce)!=="svelte-dptqqh"&&(ce.textContent=$t),be.forEach(o),Ke=r(x),T=s(x,"DIV",{class:!0});var E=w(T);g(G.$$.fragment,E),Oe=r(E),me=s(E,"P",{"data-svelte-h":!0}),i(me)!=="svelte-8teaja"&&(me.textContent=yt),et=r(E),fe=s(E,"P",{"data-svelte-h":!0}),i(fe)!=="svelte-1uc1qrl"&&(fe.textContent=Tt),tt=r(E),g(U.$$.fragment,E),E.forEach(o),x.forEach(o),Be=r(e),ve=s(e,"P",{}),w(ve).forEach(o),this.h()},h(){C(u,"name","hf:doc:metadata"),C(u,"content",Ut),C(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),C(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,l){t(document.head,u),$(e,j,l),$(e,m,l),$(e,R,l),h(H,e,l),$(e,ye,l),$(e,J,l),$(e,Te,l),h(A,e,l),$(e,xe,l),$(e,d,l),h(V,d,null),t(d,Pe),t(d,X),t(d,je),t(d,Y),t(d,ke),t(d,K),t(d,Ie),t(d,O),t(d,Ue),t(d,B),h(q,B,null),t(B,De),t(B,ee),t(B,Ee),t(B,te),t(d,He),t(d,L),h(N,L,null),t(L,Je),t(L,ae),t(L,Ae),t(L,re),t(d,Ve),t(d,I),h(S,I,null),t(I,qe),t(I,ne),$(e,we,l),h(F,e,l),$(e,Ce,l),$(e,c,l),h(W,c,null),t(c,Ne),t(c,se),t(c,Se),t(c,y),h(Z,y,null),t(y,Fe),t(y,oe),t(y,We),t(y,le),t(y,Ze),t(y,de),t(c,Qe),t(c,M),h(Q,M,null),t(M,ze),t(M,ie),t(M,Ge),t(M,pe),t(c,Re),t(c,P),h(z,P,null),t(P,Xe),t(P,ue),t(P,Ye),t(P,ce),t(c,Ke),t(c,T),h(G,T,null),t(T,Oe),t(T,me),t(T,et),t(T,fe),t(T,tt),h(U,T,null),$(e,Be,l),$(e,ve,l),Le=!0},p(e,[l]){const p={};l&2&&(p.$$scope={dirty:l,ctx:e}),U.$set(p)},i(e){Le||(_(H.$$.fragment,e),_(A.$$.fragment,e),_(V.$$.fragment,e),_(q.$$.fragment,e),_(N.$$.fragment,e),_(S.$$.fragment,e),_(F.$$.fragment,e),_(W.$$.fragment,e),_(Z.$$.fragment,e),_(Q.$$.fragment,e),_(z.$$.fragment,e),_(G.$$.fragment,e),_(U.$$.fragment,e),Le=!0)},o(e){b(H.$$.fragment,e),b(A.$$.fragment,e),b(V.$$.fragment,e),b(q.$$.fragment,e),b(N.$$.fragment,e),b(S.$$.fragment,e),b(F.$$.fragment,e),b(W.$$.fragment,e),b(Z.$$.fragment,e),b(Q.$$.fragment,e),b(z.$$.fragment,e),b(G.$$.fragment,e),b(U.$$.fragment,e),Le=!1},d(e){e&&(o(j),o(m),o(R),o(ye),o(J),o(Te),o(xe),o(d),o(we),o(Ce),o(c),o(Be),o(ve)),o(u),v(H,e),v(A,e),v(V),v(q),v(N),v(S),v(F,e),v(W),v(Z),v(Q),v(z),v(G),v(U)}}}const Ut='{"title":"Tuners","local":"tuners","sections":[{"title":"BaseTuner","local":"peft.tuners.tuners_utils.BaseTuner","sections":[],"depth":2},{"title":"BaseTunerLayer","local":"peft.tuners.tuners_utils.BaseTunerLayer","sections":[],"depth":2}],"depth":1}';function Dt($e){return wt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Nt extends Bt{constructor(u){super(),Lt(this,u,Dt,It,xt,{})}}export{Nt as component};
